package net.pingex.dcf.commands.audit;

import net.pingex.dcf.commands.Context;

/**
 * Each module which wants to audit an incoming command have to implement this interface.
 */
public interface IAuditComponentProvider
{
	/**
	 * This is the proper test method.
	 * @param context Command context
	 * @return The result of this component's audit.
	 */
	AuditResult doAudit(Context context);

	/**
	 * Gives the name of the component.
	 */
	String name();

	/**
	 * Gives a short descrpition about what this component does.
	 */
	String description();

	/**
	 * Gives the priority of this audit. Lower priority takes precedence.
	 */
	int priority();
}