package net.pingex.dcf.commands.audit.basic;

import net.pingex.dcf.commands.Context;
import net.pingex.dcf.commands.audit.AuditResult;
import net.pingex.dcf.commands.audit.IAuditComponentProvider;

/**
 * This component checks whether the command is enabled, or not.
 */
public class EnabledCheck implements IAuditComponentProvider
{
	@Override
	public AuditResult doAudit(Context context)
	{
		if(context.getCommand().isEnabled())
			return new AuditResult(AuditResult.ResultCode.PASS, null);
		else return new AuditResult(AuditResult.ResultCode.FAIL, "Command is not enabled.");
	}

	@Override
	public String name()
	{
		return "Enabled command check";
	}

	@Override
	public String description()
	{
		return "Checks whether the command is enabled, or not";
	}

	@Override
	public int priority()
	{
		return 0;
	}
}
