package net.pingex.dcf.permissions;

import net.pingex.dcf.core.Configuration;
import sx.blah.discord.handle.obj.IGuild;
import sx.blah.discord.handle.obj.IUser;
import java.util.function.Predicate;

/**
 * Default behavior when a permissions provider doesn't return `true` or `false`
 */
@Deprecated
public enum DefaultPermission implements Predicate<DefaultPermission.Tuple>
{
	/**
	 * Everyone is allowed to run the command.
	 */
	EVERYONE(tuple -> true),

	/**
	 * Only the guild owner is allowed to run the command.
	 */
	GUILD_OWNER(tuple -> tuple.guild != null && tuple.user.getID().equals(tuple.guild.getOwnerID())),

	/**
	 * Only the bot owner is allowed to run the command.
	 */
	BOT_OWNER(tuple -> tuple.user.getID().equals(Configuration.BOT_OWNER)),

	/**
	 * Guild Owner x Bot Owner
	 */
	ANY_OWNER(tuple -> GUILD_OWNER.test(tuple) || BOT_OWNER.test(tuple)),

	/**
	 * Nobody is allowed to run the command
	 */
	NONE(tuple -> false);

	DefaultPermission(Predicate<Tuple> predicate)
	{
		this.predicate = predicate;
	}

	private Predicate<Tuple> predicate;

	@Override
	public boolean test(Tuple o)
	{
		return predicate.test(o);
	}

	public static class Tuple
	{
		IUser user;
		IGuild guild;

		public Tuple(IUser user, IGuild guild)
		{
			this.user = user;
			this.guild = guild;
		}
	}
}
